#ctc_mapgen
#This file contains the code for generating and re-generating suitable maps
#for Conquer the Castle. It relies the file "perlin" in the noise library
#for the generation of the base values.

import sys
sys.path.insert(0, "noise")
import perlin

class MapGenerator:
    "Class containing all map generation methods."""
    def __init__(self):
        self.current_Map = False
        self.battle_Map = []

        self.perlinGen = perlin.SimplexNoise()

    def new_Map(self, x = 12, y = 12):
        self.battle_Map_X = x
        self.battle_Map_Y = y
        
        self.current_Map = True
        self.battle_Map = []
        self.perlinGen.randomize()

        for x in range(0, self.battle_Map_X):
            self.battle_Map.append([])
            for y in range(0, self.battle_Map_Y):
                number = self.perlinGen.noise2((x/10.0), (y/10.0))
                #divided by ten in order to get smoother perlin values
                if number < 0:
                    number = 0
                else:
                    number = number * 10
                    number = int(number)
                self.battle_Map[x].append(number)


        for x in range(0, self.battle_Map_X):
            for y in range(0, self.battle_Map_Y):
                if self.battle_Map[x][y] == 1:
                    self.battle_Map[x][y] = 0
                elif self.battle_Map[x][y] == 2:
                    self.battle_Map[x][y] = 1
                elif self.battle_Map[x][y] == 3:
                    self.battle_Map[x][y] = 1
                elif self.battle_Map[x][y] == 4:
                    self.battle_Map[x][y] = 2
                elif self.battle_Map[x][y] == 5:
                    self.battle_Map[x][y] = 2
                elif self.battle_Map[x][y] == 6:
                    self.battle_Map[x][y] = 3
                elif self.battle_Map[x][y] == 7:
                    self.battle_Map[x][y] = 3
                elif self.battle_Map[x][y] == 8:
                    self.battle_Map[x][y] = 3
                elif self.battle_Map[x][y] == 9:
                    self.battle_Map[x][y] = 4

        return self.battle_Map

    def get_Current_Map(self):
        if self.current_Map:
            return self.battle_Map
        else:
            return False
        
